package org.erikjaen.fuertesurfing;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;

import java.text.DateFormat;
import java.util.Vector;

/**
 * Created by erik on 16/11/15.
 */
public class AdaptadorComentarios extends BaseAdapter{
    private final Activity actividad;
    private final Vector<String> lista;
    static String[] listaComentarios,listaFechas;
    TextView nombreSpot,fecha_comentario;
    ImageView icono;
    RatingBar valoracion;
    LayoutInflater inflater;

    public AdaptadorComentarios(Activity actividad, Vector<String> lista){
        super();
        this.actividad = actividad;
        this.lista = lista;
        listaComentarios = new String[12];
        listaFechas = new String[12];
        inflater = actividad.getLayoutInflater();
    }
    public View getView(int position, View convertView, ViewGroup parent){
        if (convertView==null) {
            convertView = inflater.inflate(R.layout.elemento_lista, null);
        }
        nombreSpot = (TextView)convertView.findViewById(R.id.tituloSpot);
        icono = (ImageView)convertView.findViewById(R.id.icono);
        valoracion = (RatingBar)convertView.findViewById(R.id.ratingBar);
        fecha_comentario = (TextView)convertView.findViewById(R.id.fecha_elem_lista);

        switch (Math.round((float) Math.random() * 3)){
            case 0:
                icono.setImageResource(R.mipmap.face01);
                break;
            case 1:
                icono.setImageResource(R.mipmap.face02);
                break;
            case 2:
                icono.setImageResource(R.mipmap.face03);
                break;
            case 3:
                icono.setImageResource(R.mipmap.face04);
                break;
        }
        String aux ="";
        String[] cadena = lista.elementAt(position).split("\\.");
        if ((cadena[5].equals("\' \'"))||(cadena[6].equals("\' \'"))){
            aux="0";
        }else {
            aux = cadena[5] + "." + cadena[6];
        }
        nombreSpot.setText(cadena[1]);
        Float ratingValue = Float.valueOf(aux.toString());
        listaComentarios[position] = cadena[3];
        valoracion.setRating(ratingValue);
        long f = Long.valueOf(cadena[8].trim().toString());
        fecha_comentario.setText(String.valueOf(DateFormat.getInstance().format(f)));
        listaFechas[position] = String.valueOf(DateFormat.getInstance().format(f));
        return convertView;
    }
    public int getCount(){
        return lista.size();
    }
    public Object getItem(int arg0){
        return lista.elementAt(arg0);
    }
    public long getItemId(int position){
        return position;
    }



}

