package org.erikjaen.fuertesurfing;

import android.content.Context;
import android.database.Cursor;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;

import java.text.DateFormat;

/**
 * Created by erik on 25/8/15.
 */
public class AdaptadorCursorComentarios extends CursorAdapter {
    private LayoutInflater inflador;
    TextView nombreSpot,fecha_comentario;
    ImageView icono;
    RatingBar valoracion;
    static String [] comentariosCursor;
    static long[] fechasCursor;
    int num_id;

    public AdaptadorCursorComentarios(Context context, Cursor cursor){
        super(context,cursor,false);
        comentariosCursor = new String[12];
        fechasCursor = new long[12];
    }

    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        inflador = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        View vista = inflador.inflate(R.layout.elemento_lista, parent, false);
        return vista;
    }

    @Override
    public void bindView(View view, Context context, Cursor cursor) {
        nombreSpot = (TextView)view.findViewById(R.id.tituloSpot);
        nombreSpot.setText(cursor.getString(cursor.getColumnIndex("nombre")));
        icono = (ImageView)view.findViewById(R.id.icono);
        valoracion = (RatingBar)view.findViewById(R.id.ratingBar);
        valoracion.setRating(cursor.getFloat(cursor.getColumnIndex("valoracion")));
        num_id = cursor.getInt(cursor.getColumnIndex("_id"));
        comentariosCursor[num_id] = cursor.getString(cursor.getColumnIndex("comentario"));
        fechasCursor[num_id] = cursor.getLong(cursor.getColumnIndex("fecha"));
        fecha_comentario = (TextView)view.findViewById(R.id.fecha_elem_lista);
        fecha_comentario.setText(String.valueOf(DateFormat.getInstance().format(cursor.getLong(cursor.getColumnIndex("fecha")))));
        switch (Math.round((float) Math.random() * 3)){
            case 0:
                icono.setImageResource(R.mipmap.face01);
                break;
            case 1:
                icono.setImageResource(R.mipmap.face02);
                break;
            case 2:
                icono.setImageResource(R.mipmap.face03);
                break;
            case 3:
                icono.setImageResource(R.mipmap.face04);
                break;
        }

    }
}
