package org.erikjaen.fuertesurfing;

import android.util.Log;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Vector;

/**
 * Created by erik on 18/11/15.
 */
public class AlmacenComentariosPHP  {

    public void guardarOActualizarComentario(int id, String nombre,String comentario, String valoracion,String fecha) {
        try {
            URL url = new URL("http://ejaen.hol.es/comentarios/nueva.php"
                    + "?_id=" + id
                    + "&nombre=" + URLEncoder.encode(nombre, "UTF-8")
                    + "&comentario=" + URLEncoder.encode(comentario, "UTF-8")
                    + "&valoracion=" + valoracion
                    + "&fecha=" + fecha);
            HttpURLConnection conexion = (HttpURLConnection)
                    url.openConnection();
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new
                        InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                if (!linea.equals("OK")){
                    Log.e("FuerteSurfing", "Error en servicio Web nueva");
                }

            } else {
                Log.e("FuerteSurfing", conexion.getResponseMessage());
            }
            conexion.disconnect();
        }catch (Exception e) {
            Log.e("FuerteSurfing", e.getMessage(), e);
        }
    }

    public Vector<String> listaComentarios() {
        Vector<String> result = new Vector<String>();
        try {
            URL url = new URL("http://ejaen.hol.es/comentarios/lista.php");
            HttpURLConnection conexion = (HttpURLConnection)
                    url.openConnection();
            if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
                BufferedReader reader = new BufferedReader(new
                        InputStreamReader(conexion.getInputStream()));
                String linea = reader.readLine();
                while (!linea.equals("")) {
                    result.add(linea);
                    linea = reader.readLine();
                }
                reader.close();
                conexion.disconnect();
                return result;

            } else {
                Log.e("FuerteSurfing", conexion.getResponseMessage());
                conexion.disconnect();
                return result;
            }
        }catch (Exception e) {
            Log.e("FuerteSurfing", e.getMessage(), e);
            //conexion.disconnect();
            return result;
        }
    }
}
