package org.erikjaen.fuertesurfing;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import android.widget.Button;


/**
 * Created by erik on 29/10/15.
 */
public class ConfigurarAlertas extends Activity {
    Intent intent;
    boolean [] banderitaPuesta = {false,false,false,false,false,false,false,false,
            false,false,false,false};
    int num;//numero de boton pulsado devuelto por la actividad preferenciasAvisos
    int num_borrar;//numero de boton que se asocia al onclick y se usa para borrar la alerta
    Button b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12;
    public static String[] listaSpotsPreferencias = {"playa_blanca", "banderas", "el_burro", "la_entubadera",
            "punta_helena", "el_hierro", "la_derecha_de_los_alemanes", "punta_gorda", "piedra_playa",
            "esquinzo", "jarugo", "la_pared"};//Lo usaremos para dar nombre a las preferencias de cada spot

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.avisos);

        intent = new Intent(ConfigurarAlertas.this, PreferenciasAlertas.class);
        crearBotones();
    }
    @Override
    protected void onResume(){
        super.onResume();
        for (int n = 0; n < listaSpotsPreferencias.length;n++){
            SharedPreferences preferences = getBaseContext().
                    getSharedPreferences(listaSpotsPreferencias[n], Context.MODE_PRIVATE);
            if (preferences.getBoolean("bandera",false) == true){
                ponerBanderita(n);
            }
        }
    }
    //Lanza el cuadro de dialogo con dos opciones
    public void lanzarCuadroConfiguracion(View view) {
        new AlertDialog.Builder(this)
                .setTitle(R.string.dialogTitle)
                .setMessage(R.string.dialogMessage)
                .setIcon(R.mipmap.icono_app)
                .setPositiveButton(R.string.configurar, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        startActivityForResult(intent, 1234);
                    }
                })
                .setNeutralButton(R.string.borrar, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        quitarBanderita(num_borrar);
                        borrarCarpetaPreferencias(num_borrar);
                    }
                })
                .show();
    }
    //Para borrar  las preferencias del spot
    public void borrarCarpetaPreferencias(int num_spot){
        SharedPreferences preferences = getBaseContext().
                getSharedPreferences(listaSpotsPreferencias[num_spot], Context.MODE_PRIVATE);
        preferences.edit().clear().commit();

    }
    //Para crear las preferancias del spot que configuraran la notificacion
    public void crearCarpetaDePreferencias(int num_spot) {
        SharedPreferences preferences = getBaseContext().
                getSharedPreferences(listaSpotsPreferencias[num_spot], Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = preferences.edit();
        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
        editor.putString("viento_direc", pref.getString("viento_direc", "0"));
        editor.putString("viento_vel", pref.getString("viento_vel", "0"));
        editor.putString("tamanyoOla", pref.getString("tamanyoOla", "0"));
        editor.putString("periodo_ola", pref.getString("periodo_ola", "0"));
        editor.putString("direccion_ola", pref.getString("direccion_ola", "0"));
        editor.putBoolean("bandera",true);
        if (num_spot<2){
            editor.putInt("zona",1);
        }else if (num_spot<5){
            editor.putInt("zona",2);
        }else if (num_spot<7){
            editor.putInt("zona",3);
        }else{
            editor.putInt("zona",4);
        }
        editor.commit();
        /*String string = preferences.getString("viento_direc", "0")
                + preferences.getString("viento_vel", "0")
                + preferences.getString("tamanyoOla", "0")
                + preferences.getString("periodo_ola", "0")
                + preferences.getString("direccion_ola", "0");
        Toast.makeText(this, string, Toast.LENGTH_LONG).show();*/
        pref.edit().clear().commit();
    }
    //Para marcar que ya se tiene creada una notificacion en ese spot
    public void ponerBanderita(int num_boton) {
        String boton = "b" + String.valueOf(num_boton + 1);
        Drawable image = getResources().getDrawable(R.drawable.banderita);
        int h = image.getIntrinsicHeight();
        int w = image.getIntrinsicWidth();
        image.setBounds(0, 0, w, h);

        switch (boton) {
            case "b1":
                b1.setCompoundDrawables(image, null, null, null);
                break;
            case "b2":
                b2.setCompoundDrawables(image, null, null, null);
                break;
            case "b3":
                b3.setCompoundDrawables(image, null, null, null);
                break;
            case "b4":
                b4.setCompoundDrawables(image, null, null, null);
                break;
            case "b5":
                b5.setCompoundDrawables(image, null, null, null);
                break;
            case "b6":
                b6.setCompoundDrawables(image, null, null, null);
                break;
            case "b7":
                b7.setCompoundDrawables(image, null, null, null);
                break;
            case "b8":
                b8.setCompoundDrawables(image, null, null, null);
                break;
            case "b9":
                b9.setCompoundDrawables(image, null, null, null);
                break;
            case "b10":
                b10.setCompoundDrawables(image, null, null, null);
                break;
            case "b11":
                b11.setCompoundDrawables(image, null, null, null);
                break;
            case "b12":
                b12.setCompoundDrawables(image, null, null, null);
                break;

        }
    }
    //Para eliminar la marca y la notificacion creada
    public void quitarBanderita(int num_boton) {
        String boton = "b" + String.valueOf(num_boton + 1);
        switch (boton) {
            case "b1":
                b1.setCompoundDrawables(null, null, null, null);
                break;
            case "b2":
                b2.setCompoundDrawables(null, null, null, null);
                break;
            case "b3":
                b3.setCompoundDrawables(null, null, null, null);
                break;
            case "b4":
                b4.setCompoundDrawables(null, null, null, null);
                break;
            case "b5":
                b5.setCompoundDrawables(null, null, null, null);
                break;
            case "b6":
                b6.setCompoundDrawables(null, null, null, null);
                break;
            case "b7":
                b7.setCompoundDrawables(null, null, null, null);
                break;
            case "b8":
                b8.setCompoundDrawables(null, null, null, null);
                break;
            case "b9":
                b9.setCompoundDrawables(null, null, null, null);
                break;
            case "b10":
                b10.setCompoundDrawables(null, null, null, null);
                break;
            case "b11":
                b11.setCompoundDrawables(null, null, null, null);
                break;
            case "b12":
                b12.setCompoundDrawables(null, null, null, null);
                break;

        }

    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        String res = "";
        if (requestCode == 1234 && resultCode == RESULT_OK) {
            res = data.getExtras().getString("botonPulsado");
        }
        switch (res) {
            case "0":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "1":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "2":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "3":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "4":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "5":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "6":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "7":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "8":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "9":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "10":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;
            case "11":
                num = Integer.parseInt(res.toString());
                crearCarpetaDePreferencias(num);
                break;

        }

    }

    public void crearBotones() {
        //Creamos los botones y el onClick
        b1 = (Button) findViewById(R.id.bt1);
        b1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 0;
                intent.putExtra("boton", 0);
                lanzarCuadroConfiguracion(null);
            }
        });
        b2 = (Button) findViewById(R.id.bt2);
        b2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 1;
                intent.putExtra("boton", 1);
                lanzarCuadroConfiguracion(null);
            }
        });
        b3 = (Button) findViewById(R.id.bt3);
        b3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 2;
                intent.putExtra("boton", 2);
                lanzarCuadroConfiguracion(null);
            }
        });
        b4 = (Button) findViewById(R.id.bt4);
        b4.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 3;
                intent.putExtra("boton", 3);
                lanzarCuadroConfiguracion(null);
            }
        });
        b5 = (Button) findViewById(R.id.bt5);
        b5.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 4;
                intent.putExtra("boton", 4);
                lanzarCuadroConfiguracion(null);
            }
        });
        b6 = (Button) findViewById(R.id.bt6);
        b6.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 5;
                intent.putExtra("boton", 5);
                lanzarCuadroConfiguracion(null);
            }
        });
        b7 = (Button) findViewById(R.id.bt7);
        b7.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 6;
                intent.putExtra("boton", 6);
                lanzarCuadroConfiguracion(null);
            }
        });
        b8 = (Button) findViewById(R.id.bt8);
        b8.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 7;
                intent.putExtra("boton", 7);
                lanzarCuadroConfiguracion(null);
            }
        });
        b9 = (Button) findViewById(R.id.bt9);
        b9.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 8;
                intent.putExtra("boton", 8);
                lanzarCuadroConfiguracion(null);
            }
        });
        b10 = (Button) findViewById(R.id.bt10);
        b10.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 9;
                intent.putExtra("boton", 9);
                lanzarCuadroConfiguracion(null);
            }
        });
        b11 = (Button) findViewById(R.id.bt11);
        b11.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 10;
                intent.putExtra("boton", 10);
                lanzarCuadroConfiguracion(null);
            }
        });
        b12 = (Button) findViewById(R.id.bt12);
        b12.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                num_borrar = 11;
                intent.putExtra("boton", 11);
                lanzarCuadroConfiguracion(null);
            }
        });
    }
}


