package org.erikjaen.fuertesurfing;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.StrictMode;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * Created by erik on 2/11/15.
 */
public class MuestraLaAlerta extends AppCompatActivity {
    boolean imprimirDatos = false ;
    int i = 0;//Para usar en el editext
    TextView spots, fechaYhora,tituloZona;
    int[] datosV1 = new int[2],datosV2 = new int[2];
    public static String[] listaSpots = {"Playa Blanca", "Banderas", "El Burro", "La Entubadera",
            "Punta Helena", "El Hierro", "La derecha de los Alemanes", "Punta Gorda", "Piedra Playa",
            "Esquinzo", "Jarugo", "La Pared"};

    static String[] alturaOla = new String[9],direccionOla= new String[9],
            direccionViento = new String[9];
    private static final int ID_NOTIFICACION_CREAR = 1;
    static  int[] periodo_olaZona1 = new int[8],velocidad_vientoZona1 = new int[8],
            direccion_ola = new int[8],direccion_viento = new int[8];
    static  double[] altura_olaZona1 = new double[8];
    static String textStr[],textStr1[];
    static String[] zonas ={"puerto-lajas","corralejo","la-costa-norte","el-cotillo"};

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.muestra_alerta);
        StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().
                permitNetwork().build());
        buscar(null);
        /*try {
            resultadoPagWebZona1(zonas[LanzarServicios.zonaABuscar]);
        } catch (Exception e) {
            Log.e("HTTP", e.getMessage(), e);
        }*/

    }
    @Override
    protected void onStart(){
        super.onStart();
    }
    class BuscarPrediccion extends AsyncTask<String, Void, String> {
        private ProgressDialog progreso;

        @Override protected void onPreExecute() {
            progreso = new ProgressDialog(MuestraLaAlerta.this);
            progreso.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            progreso.setMessage("Accediendo a la predicción...");
            progreso.setCancelable(false);
            progreso.show();
        }
        @Override protected String doInBackground(String... palabras) {
            try{
                return resultadoPagWebZona1(palabras[0]);
            } catch(Exception e) {
                cancel(true);
                Log.e("HTTP", e.getMessage(), e);
                return null;
            }
        }
        @Override protected void onPostExecute(String res) {
            progreso.dismiss();
            tituloZona = (TextView) findViewById(R.id.tituloSpots);
            ponerTituloZona(LanzarServicios.zonaABuscar);
            spots = (TextView)findViewById(R.id.spots);
            fechaYhora = (TextView)findViewById(R.id.datosFH);

            comprobarAlertasAMandar(direccion_viento, velocidad_vientoZona1,
                    altura_olaZona1, periodo_olaZona1, direccion_ola,LanzarServicios.zonaABuscar +1);
            if (imprimirDatos) {
                rellenarTexto();
            }else{
                Toast.makeText(getBaseContext(),R.string.avisoNoCoincidencias,Toast.LENGTH_LONG).show();
            }
            /*else {
            new AlertDialog.Builder(this)
                    .setTitle(R.string.aviso)
                    .setMessage(R.string.avisoNoCoincidencias)
                    .setIcon(R.mipmap.icono_app)
                    .setPositiveButton(R.string.volver, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            Intent intent = new Intent(MuestraLaAlerta.this,LanzarServicios.class);
                            startActivity(intent);
                        }
                    })
                    .show();
        }*/
            //Para obtener la hora actual
            Calendar c = Calendar.getInstance();
            SimpleDateFormat df = new SimpleDateFormat("yy-MM-dd");
            String formattedDate = df.format(c.getTime());
            fechaYhora.setText(formattedDate);
        }
        @Override protected void onCancelled() {
            progreso.dismiss();
        }
    }
    //Rellenemos la tabla con los datos obtenidos de la pagina web
    public void rellenarTexto(){
        ImageView vd1 = (ImageView) findViewById(R.id.vd1);
        vd1.setImageResource(R.drawable.flecha);
        vd1.setRotation((float) direccion_viento[2]);
        ImageView vd2 = (ImageView) findViewById(R.id.vd2);
        vd2.setImageResource(R.drawable.flecha);
        vd2.setRotation((float) direccion_viento[3]);
        ImageView vd3 = (ImageView) findViewById(R.id.vd3);
        vd3.setImageResource(R.drawable.flecha);
        vd3.setRotation((float) direccion_viento[4]);
        ImageView vd4 = (ImageView) findViewById(R.id.vd4);
        vd4.setImageResource(R.drawable.flecha);
        vd4.setRotation((float) direccion_viento[5]);
        ImageView vd5 = (ImageView) findViewById(R.id.vd5);
        vd5.setImageResource(R.drawable.flecha);
        vd5.setRotation((float) direccion_viento[6]);
        ImageView vd6 = (ImageView) findViewById(R.id.vd6);
        vd6.setImageResource(R.drawable.flecha);
        vd6.setRotation((float) direccion_viento[7]);

        TextView vv1 = (TextView) findViewById(R.id.vv1);
        vv1.append(String.valueOf(velocidad_vientoZona1[2]));
        TextView vv2 = (TextView) findViewById(R.id.vv2);
        vv2.append(String.valueOf(velocidad_vientoZona1[3]));
        TextView vv3 = (TextView) findViewById(R.id.vv3);
        vv3.append(String.valueOf(velocidad_vientoZona1[4]));
        TextView vv4 = (TextView) findViewById(R.id.vv4);
        vv4.append(String.valueOf(velocidad_vientoZona1[5]));
        TextView vv5 = (TextView) findViewById(R.id.vv5);
        vv5.append(String.valueOf(velocidad_vientoZona1[6]));
        TextView vv6 = (TextView) findViewById(R.id.vv6);
        vv6.append(String.valueOf(velocidad_vientoZona1[7]));

        TextView oa1 = (TextView)findViewById(R.id.oa1);
        oa1.append(String.valueOf(altura_olaZona1[2]));
        TextView oa2 = (TextView)findViewById(R.id.oa2);
        oa2.append(String.valueOf(altura_olaZona1[3]));
        TextView oa3 = (TextView)findViewById(R.id.oa3);
        oa3.append(String.valueOf(altura_olaZona1[4]));
        TextView oa4 = (TextView)findViewById(R.id.oa4);
        oa4.append(String.valueOf(altura_olaZona1[5]));
        TextView oa5 = (TextView)findViewById(R.id.oa5);
        oa5.append(String.valueOf(altura_olaZona1[6]));
        TextView oa6 = (TextView)findViewById(R.id.oa6);
        oa6.append(String.valueOf(altura_olaZona1[7]));


        TextView op1 = (TextView)findViewById(R.id.op1);
        op1.append(String.valueOf(periodo_olaZona1[2]));
        TextView op2 = (TextView)findViewById(R.id.op2);
        op2.append(String.valueOf(periodo_olaZona1[3]));
        TextView op3 = (TextView)findViewById(R.id.op3);
        op3.append(String.valueOf(periodo_olaZona1[4]));
        TextView op4 = (TextView)findViewById(R.id.op4);
        op4.append(String.valueOf(periodo_olaZona1[5]));
        TextView op5 = (TextView)findViewById(R.id.op5);
        op5.append(String.valueOf(periodo_olaZona1[6]));
        TextView op6 = (TextView)findViewById(R.id.op6);
        op6.append(String.valueOf(periodo_olaZona1[7]));

        ImageView od1 = (ImageView) findViewById(R.id.od1);
        od1.setImageResource(R.drawable.flecha);
        od1.setRotation((float) direccion_ola[2]);
        ImageView od2 = (ImageView) findViewById(R.id.od2);
        od2.setImageResource(R.drawable.flecha);
        od2.setRotation((float) direccion_ola[3]);
        ImageView od3 = (ImageView) findViewById(R.id.od3);
        od3.setImageResource(R.drawable.flecha);
        od3.setRotation((float) direccion_ola[4]);
        ImageView od4 = (ImageView) findViewById(R.id.od4);
        od4.setImageResource(R.drawable.flecha);
        od4.setRotation((float) direccion_ola[5]);
        ImageView od5 = (ImageView) findViewById(R.id.od5);
        od5.setImageResource(R.drawable.flecha);
        od5.setRotation((float) direccion_ola[6]);
        ImageView od6 = (ImageView) findViewById(R.id.od6);
        od6.setImageResource(R.drawable.flecha);
        od6.setRotation((float) direccion_ola[7]);
    }
    //Obtenemos los datos guardados en las preferencias de cada spot
    public int[] obtenerDatosPref(SharedPreferences pref) {
        int[] datosPref = new int[5];
        datosPref[0] = Integer.parseInt(pref.getString("viento_direc", "0"));
        datosPref[1] = Integer.parseInt(pref.getString("viento_vel", "0"));
        datosPref[2] = Integer.parseInt((pref.getString("tamanyoOla", "0")));
        datosPref[3] = Integer.parseInt((pref.getString("periodo_ola", "0")));
        datosPref[4] = Integer.parseInt((pref.getString("direccion_ola", "0")));
        switch (datosPref[0]){
            case 1:
                datosV1[0] = 330;
                datosV1[1] = 30;
                break;
            case 2:
                datosV1[0] =151;
                datosV1[1] =210;
                break;
            case 3:
                datosV1[0] = 61;
                datosV1[1] = 120;
                break;
            case 4:
                datosV1[0] =241;
                datosV1[1] =300;
                break;
            case 5:
                datosV1[0] =301 ;
                datosV1[1] =330 ;
                break;
            case 6:
                datosV1[0] =31;
                datosV1[1] =60;
                break;
            case 7:
                datosV1[0] =211;
                datosV1[1] =240;
                break;
            case 8:
                datosV1[0] =121;
                datosV1[1] =150;
                break;
        }
        switch (datosPref[1]) {
            case 1:
                datosPref[1] = 10;
                break;
            case 2:
                datosPref[1] = 20;
                break;
            case 3:
                datosPref[1] = 30;
                break;
        }
        switch (datosPref[2]) {
            case 1:
                datosPref[2] = 0;
                break;
            case 2:
                datosPref[2] = 1;
                break;
            case 3:
                datosPref[2] = 2;
                break;
        }
        switch (datosPref[3]) {
            case 1:
                datosPref[3] = 5;
                break;
            case 2:
                datosPref[3] = 10;
                break;
            case 3:
                datosPref[3] = 15;
                break;
        }
        switch (datosPref[4]){
            case 1:
                datosV2[0] =330;
                datosV2[1] =30;
                break;
            case 2:
                datosV2[0] =151;
                datosV2[1] =210;
                break;
            case 3:
                datosV2[0] =61;
                datosV2[1] =120;
                break;
            case 4:
                datosV2[0] =241;
                datosV2[1] =300;
                break;
            case 5:
                datosV2[0] =301;
                datosV2[1] =330;
                break;
            case 6:
                datosV2[0] =31;
                datosV2[1] =60;
                break;
            case 7:
                datosV2[0] =211;
                datosV2[1] =240;
                break;
            case 8:
                datosV2[0] =121;
                datosV2[1] =150;
                break;
        }
        return datosPref;
    }
    //Recoger alertas activadas y comparar sus datos con la web
    public void comprobarAlertasAMandar(int[] d_v,int[] v_v, double[] a_o, int[] p_o, int[] d_o,int zonaSelecc){
        int dato0,dato1,dato3,dato4,auxDato0,auxDato4;
        double dato2;
        for (int n=0;n< ConfigurarAlertas.listaSpotsPreferencias.length;n++) {
            SharedPreferences preferences = getBaseContext().
                    getSharedPreferences(ConfigurarAlertas.listaSpotsPreferencias[n], Context.MODE_PRIVATE);
            if ((preferences.getBoolean("bandera",false)) && (preferences.getInt("zona", 4) == zonaSelecc)){
                int[] aux = obtenerDatosPref(preferences);
                dato0 = aux[0];
                dato4 = aux[4];
                dato1 = aux[1];
                if (aux[2] == 0){//cambiamos el 0 de las preferencias altura ola y lo pasamos al minimo 0,5
                    dato2 =0.5;
                }else {
                    dato2 = (double)aux[2];
                }
                dato3 = aux[3];
                for (int a = 0; a < v_v.length; a++) {
                    if (dato1 >= v_v[a] || dato1 == 0) {
                        for (int b = 0; b < a_o.length; b++) {
                            if (a_o[b] >= dato2 || dato2 == 0) {
                                for (int c = 0; c < p_o.length; c++) {
                                    if (p_o[c] >= dato3 || dato3 == 0) {
                                        //Ajustamos los datos cuando la direccion de viento y ola esta entre 330 y 30 grados
                                        for (int z = 0; z < d_v.length;z++) {
                                           if ((datosV1[0] <= d_v[z] && datosV1[1] >= d_v[z]) || (dato0 == 0) ||
                                                   (( 330 <= d_v[z] && 360 >= d_v[z])|| (0 <= d_v[z] && 30 >= d_v[z]))) {
                                               for (int x = 0; x < d_o.length;x++) {
                                                   if ((datosV2[0] <= d_o[x] && datosV2[1] >= d_o[x]) || (dato4 == 0) ||
                                                           ((330 <= d_o[x] && 360 >= d_o[x]) || (0 <= d_o[x] && 30 >= d_o[x]))) {
                                                             imprimirDatos = true;
                                                             if (i == 0) {
                                                                 Drawable image = getResources().getDrawable(R.drawable.alerta_ok);
                                                                 int h = image.getIntrinsicHeight();
                                                                 int w = image.getIntrinsicWidth();
                                                                 image.setBounds(0, 0, w, h);
                                                                 spots.setCompoundDrawables(image, null, null, null);
                                                                 spots.append("  " + listaSpots[n]);
                                                                 i++;
                                                             } else {
                                                                 spots.append(" / " + listaSpots[n]);
                                                             }
                                                       break;
                                                   }
                                               }
                                               break;
                                            }
                                        }
                                        break;
                                    }
                                }
                                break;
                            }
                        }
                        break;
                    }
                }

            }


        }
    }
    public  void ponerTituloZona(int num_zona){
        switch (num_zona){
            case 0:
                tituloZona.setText(getString(R.string.zona1));
                break;
            case 1:
                tituloZona.setText(getString(R.string.zona2));
                break;
            case 2:
                tituloZona.setText(getString(R.string.zona3));
                break;
            case 3:
                tituloZona.setText(getString(R.string.zona4));
                break;
        }
    }
    public String resultadoPagWebZona1(String zona) throws Exception{
        String pagina = "", devuelve = "",pagina2="",pagina1="";
        String delimiterOlasAltura ="sdval=",delimiterOlasPeriodo ="sdval=",delimiterOlasDireccion="title=",
                delimiterVientoVelocidad="sdval=",delimiterVientoDireccion="title=";
        String vientoDireccion = "",vientoVelocidad="",olasAltura ="",
                olasPeriodo = "",olasDireccion ="";

        URL url = new URL("http://www.fuerteventuraplayas.com/es/tiempo-en-fuerteventura/prevision-surf/" + zona);
        HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
        conexion.setRequestProperty("User-Agent", "Mozilla/5.0 (Windows NT 6.1)");
        if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {
            BufferedReader reader = new BufferedReader(new
                    InputStreamReader(conexion.getInputStream()));
            String linea = reader.readLine();
            while (linea != null) {
                pagina += linea;
                linea = reader.readLine();
            }
            reader.close();

            //Info olas
            int i = pagina.indexOf("Oleaje");
            int f = pagina.indexOf("de_viento");
            pagina1 = pagina.substring(i, f);
            //Info viento
            int i2 = pagina.indexOf("Viento");
            int f2 = pagina.indexOf("Altura_(m)");
            pagina2 = pagina.substring(i2, f2);

            //Viento direccion
            int ini00 = pagina2.indexOf("Dirección");
            if (ini00 != -1) {
                String[] cadena;
                int fin00 = pagina2.indexOf("Velocidad");
                vientoDireccion = pagina2.substring(ini00, fin00);
                cadena = vientoDireccion.split(delimiterVientoDireccion);
                for (int n = 1; n < 9; n++) {
                    direccionViento[n] = cadena[n].substring(1, cadena[n].indexOf("\" src"));
                }
                //Dejamos cada string solo con los grados en numeros
                for (int n = 1; n < 9; n++) {
                    String aux,aux2 ="";
                    textStr = direccionViento[n].split("\\(");
                    aux =textStr[1];
                    textStr1= aux.split("\\)");
                    CharSequence c = textStr1[0];
                    for (int a = 0;a< c.length() - 1;a++){
                        aux2 += c.charAt(a);
                    }
                    direccion_viento[n-1] = Integer.parseInt(aux2);
                }

            } else {
                devuelve += "no encontrado";
            }
            //Viento velocidad
            int ini01 = pagina2.indexOf("Velocidad");
            if (ini01 != -1) {
                String[] cadena;
                int fin01 = pagina2.indexOf("Oleaje");
                vientoVelocidad = pagina2.substring(ini01, fin01);
                cadena = vientoVelocidad.split(delimiterVientoVelocidad);
                for (int n = 1; n < 9; n++) {
                    velocidad_vientoZona1[n-1] = Integer.parseInt(cadena[n].substring(1, cadena[n].indexOf("\" sdnum")));
                }
            } else {
                devuelve = "no encontrado";
            }
            //Altura ola
            int ini = pagina1.indexOf("Altura_(m)");
            if (ini != -1) {
                String[] cadena;
                int fin = pagina1.indexOf("Periodo");
                olasAltura = pagina1.substring(ini, fin);
                cadena = olasAltura.split(delimiterOlasAltura);
                for (int n = 1; n < 9; n++) {
                    alturaOla[n] = cadena[n].substring(1, cadena[n].indexOf("\" sdnum"));
                    //Para cambiar la coma por el punto
                    if (alturaOla[n].contains(",")) {
                        char[] myNameChars = alturaOla[n].toCharArray();
                        myNameChars[1] = '.';
                        alturaOla[n] = String.valueOf(myNameChars);
                    }else {
                        alturaOla[n] += ".0";
                    }
                    altura_olaZona1[n-1] = Double.parseDouble(alturaOla[n]);
                }
            } else {
                devuelve = "no encontrado";
            }
            //Periodo ola
            int ini2 = pagina1.indexOf("Periodo");
            if (ini2 != -1) {
                String[] cadena;
                int fin2 = pagina1.indexOf("Dirección");
                olasPeriodo = pagina1.substring(ini2, fin2);
                cadena = olasPeriodo.split(delimiterOlasPeriodo);
                for (int n = 1; n < 9; n++) {
                    periodo_olaZona1[n-1] = Integer.parseInt(cadena[n].substring(1, cadena[n].indexOf("\" sdnum")));
                }
            } else {
                devuelve = "no encontrado";
            }
            //Direccion ola
            int ini3 = pagina1.indexOf("Dirección");
            if (ini3 != -1) {
                String[] cadena;
                int fin3 = pagina1.indexOf(">Olas");
                olasDireccion = pagina1.substring(ini3, fin3);
                cadena = olasDireccion.split(delimiterOlasDireccion);
                for (int n = 1; n < 9; n++) {
                    direccionOla[n] = cadena[n].substring(1, cadena[n].indexOf("\" src"));
                }
                //Dejamos cada string solo con los grados en numeros
                for (int n = 1; n < 9; n++) {
                    String aux,aux2 ="";
                    textStr = direccionOla[n].split("\\(");
                    aux =textStr[1];
                    textStr1= aux.split("\\)");
                    CharSequence c = textStr1[0];
                    for (int a = 0;a< c.length() - 1;a++){
                        aux2 += c.charAt(a);
                    }
                    direccion_ola[n-1] = Integer.parseInt(aux2);
                }
            } else {
                devuelve = "no encontrado";
            }


        } else {
            Log.e("ERROR : ", conexion.getResponseMessage());
        }
        conexion.disconnect();
        return "";
    }
    public void buscar(View view){
        new BuscarPrediccion().execute(zonas[LanzarServicios.zonaABuscar]);
    }
}

