package org.erikjaen.fuertesurfing;

import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.view.View;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

/**
 * Created by erik on 13/11/15.
 */
public class VerMapa extends FragmentActivity implements GoogleMap.OnMapClickListener {
    public  LatLng [] coordenadasSPots = new LatLng[12];
    private  LatLng la_pared = new LatLng(28.2141,-14.2235);
    private  LatLng jarugo = new LatLng(28.5712,-14.0478);
    private  LatLng esquinzo = new LatLng(28.6351,-14.0264);
    private  LatLng piedra_playa = new LatLng(28.6702,-14.0103);
    private  LatLng punta_gorda = new LatLng(28.7198,-13.9980);
    private  LatLng el_hierro = new LatLng(28.7389,-13.9517);
    private  LatLng la_derecha = new LatLng(28.7389,-13.9517);
    private  LatLng punta_helena = new LatLng(28.7303,-13.8569);
    private  LatLng la_entubadera = new LatLng(28.7166,-13.8390);
    private  LatLng el_burro = new LatLng(28.6873,-13.8313);
    private  LatLng banderas = new LatLng(28.5639,-13.8291);
    private  LatLng playa_blanca = new LatLng(28.4767,-13.8669);
    private GoogleMap mapa;
    int id_coordenadas;

    @Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.ver_mapa);
        addSpotsCordenadas();
        Bundle extras = getIntent().getExtras();
        id_coordenadas = extras.getInt("idComentario");
        mapa = ((SupportMapFragment) getSupportFragmentManager()
                .findFragmentById(R.id.map)).getMap();
        mapa.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
        mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(coordenadasSPots[id_coordenadas], 17));
        mapa.setMyLocationEnabled(true);
        mapa.getUiSettings().setZoomControlsEnabled(false);
        mapa.getUiSettings().setCompassEnabled(true);
        mapa.addMarker(new MarkerOptions()
                .position(coordenadasSPots[id_coordenadas])
                .title(MuestraLaAlerta.listaSpots[id_coordenadas])
                .icon(BitmapDescriptorFactory
                        .fromResource(android.R.drawable.ic_menu_compass))
                .anchor(0.5f, 0.5f));
        mapa.setOnMapClickListener(this);
    }

    public void moveCamera(View view) {
        mapa.moveCamera(CameraUpdateFactory.newLatLng(coordenadasSPots[id_coordenadas]));
    }

    public void animateCamera(View view) {
        if (mapa.getMyLocation() != null)
            mapa.animateCamera(CameraUpdateFactory.newLatLngZoom(
                    new LatLng( mapa.getMyLocation().getLatitude(),
                            mapa.getMyLocation().getLongitude()), 15));
    }

    public void addMarker(View view) {
        mapa.addMarker(new MarkerOptions().position(
                new LatLng(mapa.getCameraPosition().target.latitude,
                        mapa.getCameraPosition().target.longitude)));
    }

    @Override
    public void onMapClick(LatLng puntoPulsado) {
        mapa.addMarker(new MarkerOptions().position(puntoPulsado).
                icon(BitmapDescriptorFactory
                        .defaultMarker(BitmapDescriptorFactory.HUE_YELLOW)));
    }
    public void addSpotsCordenadas(){
        coordenadasSPots[0] = playa_blanca ;
        coordenadasSPots[1] = banderas;
        coordenadasSPots[2] = el_burro;
        coordenadasSPots[3] = la_entubadera;
        coordenadasSPots[4] = punta_helena;
        coordenadasSPots[5] = el_hierro;
        coordenadasSPots[6] = la_derecha;
        coordenadasSPots[7] = punta_gorda;
        coordenadasSPots[8] = piedra_playa;
        coordenadasSPots[9] = esquinzo;
        coordenadasSPots[10] = jarugo;
        coordenadasSPots[11] = la_pared;
    }
}
